unit cfg;

interface

uses inifiles,forms, Graphics, SysUtils, Classes, ShellApi, Windows,
  comctrls, DateUtils;

  procedure loadCFG;
  procedure SaveCFG;
  procedure WriteLog(const FileName,Error,Place:string);
  function ColorToHexRGB(color:Tcolor):string;
  function GetAllNotesNames:TStringlist;
  function SortNames(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortHPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortWPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortCelPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortDate(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortAdres(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
  function SortEmail(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;

const log='C:\aSPL_PBD.LOG';
var
  added_Index:integer;
  sorttype:array [0..6]of byte=(0,1,1,1,1,1,1);
  defnum:integer=maxint;
 sortindex:integer=0;
implementation

uses main;

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
// 
function SortNames(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
begin
  result:=-999;
  s1:=trim(Item1.caption);
  s2:=trim(Item2.caption);
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := CompareText(s1,s2);
    //descending
    0:  Result := -CompareText(s1,s2);
  end;
end;

//   
function SortHPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
begin
  result:=-999;
  s1:=trim(Item1.SubItems[0]);
  s2:=trim(Item2.SubItems[0]);
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := CompareText(s1,s2);
    //descending
    0:  Result := -CompareText(s1,s2);
  end;
end;

//   
function SortWPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
begin
  result:=-999;
  s1:=trim(Item1.SubItems[1]);
  s2:=trim(Item2.SubItems[1]);
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := CompareText(s1,s2);
    //descending
    0:  Result := -CompareText(s1,s2);
  end;

end;

//   
function SortCelPhones(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
begin
  result:=-999;
  s1:=trim(Item1.SubItems[2]);
  s2:=trim(Item2.SubItems[2]);
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['+','0'..'9','A'..'Z','a'..'z',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['+','0'..'9','A'..'Z','a'..'z',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['+','0'..'9','A'..'Z','a'..'z',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['+','0'..'9','A'..'Z','a'..'z',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := CompareText(s1,s2);
    //descending
    0:  Result := -CompareText(s1,s2);
  end;

end;

// 
function SortAdres(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
//    p:integer;
begin
  result:=-999;
  s1:=trim(Item1.SubItems[3]);
  s2:=trim(Item2.SubItems[3]);
  //
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..'',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..'',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..'',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..'',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := ANSICompareText(s1,s2);
    //descending
    0:  Result := -ANSICompareText(s1,s2);
  end;

end;

// .
function SortEmail(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
begin
  result:=-999;
  s1:=trim(Item1.SubItems[4]);
  s2:=trim(Item2.SubItems[4]);
  if paramsort=1 then begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=''+s1;
     end else s1:='';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=''+s2;
     end else s2:='';
  end
  else begin
     if length(s1)>0 then begin
        if not(s1[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s1:=' '+s1;
     end else s1:=' ';
     if length(s2)>0 then begin
        if not(s2[1]in ['0'..'9','A'..'Z','a'..'z',''..''])then s2:=' '+s2;
     end else s2:=' ';
  end;
  case paramsort of
    //ascending
    1:  Result := CompareText(s1,s2);
    //descending
    0:  Result := -CompareText(s1,s2);
  end;
end;

//  
function SortDate(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var s1,s2:string;
    d1,d2:TDateTime;
//    y,d,w1,w2:word;
begin
  result:=-999;
  s1:=Item1.SubItems[5];
  s2:=Item2.SubItems[5];
  d1:= StrToDateDef(s1,StrToDate('01.01.3000'));
  d2:= StrToDateDef(s2,StrToDate('01.01.3000'));
  case paramsort of
    //ascending
    1: begin
         d1:= StrToDateDef(s1,StrToDate('01.01.3000'));
         d2:= StrToDateDef(s2,StrToDate('01.01.3000'));
         Result := CompareDate(d1,d2);
       end;
    //descending
    0: begin
         d1:= StrToDateDef(s1,StrToDate('01.01.1000'));
         d2:= StrToDateDef(s2,StrToDate('01.01.1000'));
         Result := -CompareDate(d1,d2);
       end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//     
////////////////////////////////////////////////////////////////////////////////
function GetAllNotesNames:TStringlist;
var f:TSearchRec;
    n:integer;
begin
  result:=TStringlist.Create;
  result.Clear;
  Try
    if findfirst(dir+'text\*.txt',faAnyFile-(faDirectory+faVolumeID),f)=0 then
      repeat
        n:=lastdelimiter('\',f.name);
        Result.Add(copy(f.name,n,length(f.name)-n-4));
      until findnext(f)<>0;
      sysUtils.FindClose(f);
  except
    writeLog(Log,'GetNotesListError','cfg.pas->GetAllNotesNames');
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//     HTML-HEX 
////////////////////////////////////////////////////////////////////////////////
function ColorToHexRGB(color:Tcolor):string;
var tmp,hex:string;
begin
  tmp:=inttohex(Color,6);
  hex:='';
  hex:=hex+system.copy(tmp,5,2);
  hex:=hex+system.copy(tmp,3,2);
  hex:=hex+system.copy(tmp,1,2);
  result:=hex;
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure WriteLog(const FileName,Error,Place:string);
var f:TextFile;
    s:string;
    size:Integer;
    f1:file of byte;
begin
// {
    AssignFile(f1,FileName);
    if not FileExists(FileName) then Rewrite(f1)
    else reset(f1);
    size:=FileSize(f1);
    CloseFile(f1);
// }
    AssignFile(f,FileName);
    if FileExists(FileName)and(size<102400) then
       Append(f)
    else Rewrite(F);
    s:=dateTimetostr(now)+' : '+Error+' ['+Place+']';
    WriteLn(f,s);
    CloseFile(f);
//
end;

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure loadCFG;
var cfgini:Tinifile;
    fs:string;
    i:integer;
begin
  try
    fileSetAttr(dir+'PhoneBook.ini',$00);
    cfgini:=tinifile.Create(dir+'PhoneBook.ini');
    PhoneBook.files.Font.Size:=cfgini.ReadInteger('Notes','FontSize',12);
    PhoneBook.files.Font.name:=cfgini.ReadString('Notes','FontFace','CourierNew');
    fs:=cfgini.ReadString('Notes','FontStyle', '0000');
    PhoneBook.files.font.Style:=[];
    if fs[1]='1' then PhoneBook.files.font.Style:=PhoneBook.files.font.Style+[fsBold];
    if fs[2]='1' then PhoneBook.files.font.Style:=PhoneBook.files.font.Style+[fsItalic];
    if fs[3]='1' then PhoneBook.files.font.Style:=PhoneBook.files.font.Style+[fsUnderline];
    if fs[4]='1' then PhoneBook.files.font.Style:=PhoneBook.files.font.Style+[fsStrikeOut];
    //-*- 
    PhoneBook.CheckBox5.Checked:=cfgini.ReadBool('MAIN','ESC',True);
    PhoneBook.ComboBox1.ItemIndex:=cfgini.ReadInteger('MAIN','TabPosition',0);
    PhoneBook.PageControl1.ActivePageIndex:=cfgini.ReadInteger('MAIN','Page',0);
    PhoneBook.PageControl1.Update;
    phonebook.WindowState:=wsNormal;
    phonebook.WindowState:=wsmaximized;
    phonebook.WindowState:=wsNormal;
    PhoneBook.Width:=cfgini.ReadInteger('MAIN','Width',640);
    PhoneBook.Height:=cfgini.ReadInteger('MAIN','Height',480);
    PhoneBook.Top:=cfgini.ReadInteger('MAIN','Top', 100);
    PhoneBook.Left:=cfgini.ReadInteger('MAIN','Left',100);
    phonebook.WindowState:=wsNormal;
    if cfgini.ReadBool('MAIN','Max',false) then
        phonebook.WindowState:=wsMaximized;
    //  
    PhoneBook.CheckBox2.Checked:=cfgini.ReadBool('PB','Pans',true);
    PhoneBook.CheckBox3.Checked:=cfgini.ReadBool('PB','Comments',true);
    PhoneBook.comment.Height:=cfgini.ReadInteger('PB','ComHeight',50);
    PhoneBook.Groups.Width:=cfgini.ReadInteger('PB','GroupWidth',120);
    //  
    PhoneBook.CheckBox1.Checked:=cfgini.ReadBool('Notes','WordWrap',true);
    PhoneBook.n8.Checked:=PhoneBook.checkbox1.Checked;
    PhoneBook.toolbar1.left:=cfgini.Readinteger('Notes','CP1L',280);
    PhoneBook.toolbar1.top :=cfgini.Readinteger('Notes','CP1T',2);
    PhoneBook.toolbar1.visible:=cfgini.ReadBool('Notes','CP1V',true);
    PhoneBook.List.Width:=cfgini.Readinteger('Notes','LW',192);
    tab:=stringofchar(' ',cfgini.ReadInteger('Notes','TabCount',8));
    phonebook.checkbox8.checked:=cfgini.readBool('Notes','ConfirmDnD',true);
    //   
    for i:=0 to PhoneBook.list.items.Count-1 do begin
      PhoneBook.list.items[i].Expanded:=cfgini.ReadBool('Expanded',PhoneBook.list.items[i].text,false);
      if PhoneBook.list.items[i].text= cfgini.ReadString('Expanded','SelectedItem','$') then
         PhoneBook.list.items[i].Selected:=true;
    end;
    phonebook.bgcolor.font.color:=cfgini.readInteger('ExportHTML','bgcolor',clSilver);
    phonebook.textcolor.font.color:=cfgini.readInteger('ExportHTML','textcolor',clBlack);
    phonebook.bordercolor.font.color:=cfgini.readInteger('ExportHTML','bordercolor',clSkyBlue);
    phonebook.border.Checked:=cfgini.readBool('ExportHTML','border',true);
    phonebook.cb1.Checked:=cfgini.readBool('ExportHTML','1',true);
    phonebook.cb2.Checked:=cfgini.readBool('ExportHTML','2',true);
    phonebook.cb3.Checked:=cfgini.readBool('ExportHTML','3',true);
    phonebook.cb4.Checked:=cfgini.readBool('ExportHTML','4',true);
    phonebook.cb5.Checked:=cfgini.readBool('ExportHTML','5',true);
    _II:=cfgini.ReadInteger('PB','GroupNum',-1);
    for i:=0 to phonebook.Phones.Columns.Count-1 do
      phonebook.Phones.Column[i].Width:=cfgini.readInteger('PB',phonebook.Phones.Column[i].Caption,100);
  except
    writeLog(log,'LoadCfgError','CFG.pas->LoadCFG');
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure SaveCFG;
var cfgini:Tinifile;
    i:integer;
begin
  try
    fileSetAttr(dir+'PhoneBook.ini',$00);
    cfgini:=tinifile.Create(dir+'PhoneBook.ini');
    //-*- 
    cfgini.WriteInteger('MAIN','TabPosition',PhoneBook.ComboBox1.ItemIndex);
    cfgini.WriteInteger('MAIN','Page',PhoneBook.PageControl1.ActivePageIndex);
    cfgini.WriteBool('MAIN','ESC',PhoneBook.CheckBox5.Checked);
    if phonebook.WindowState=wsMaximized then
       cfgini.WriteBool('MAIN','Max',True)
    else  begin cfgini.WriteBool('MAIN','Max',False);
       cfgini.WriteInteger('MAIN','Width',PhoneBook.Width);
       cfgini.WriteInteger('MAIN','Height',PhoneBook.Height);
       cfgini.WriteInteger('MAIN','Top',PhoneBook.Top );
       cfgini.WriteInteger('MAIN','Left',PhoneBook.Left);
    end;
    //-*- 
    cfgini.WriteBool('PB','Pans',PhoneBook.CheckBox2.Checked);
    cfgini.WriteBool('PB','Comments',PhoneBook.CheckBox3.Checked);
    cfgini.WriteInteger('PB','ComHeight',PhoneBook.comment.Height);
    cfgini.WriteInteger('PB','GroupWidth',PhoneBook.Groups.Width);
    cfgini.WriteInteger('ExportHTML','bgcolor',phonebook.bgcolor.font.color);
    cfgini.WriteInteger('ExportHTML','textcolor',phonebook.textcolor.font.color);
    cfgini.WriteInteger('ExportHTML','bordercolor',phonebook.bordercolor.font.color);
    cfgini.WriteBool('ExportHTML','border',phonebook.border.Checked);
    cfgini.WriteBool('ExportHTML','1',phonebook.cb1.Checked);
    cfgini.WriteBool('ExportHTML','2',phonebook.cb2.Checked);
    cfgini.WriteBool('ExportHTML','3',phonebook.cb3.Checked);
    cfgini.WriteBool('ExportHTML','4',phonebook.cb4.Checked);
    cfgini.WriteBool('ExportHTML','5',phonebook.cb5.Checked);
    cfgini.WriteInteger('PB','GroupNum',phonebook.Groups.ItemIndex);
    for i:=0 to phonebook.Phones.Columns.Count-1 do
      cfgini.WriteInteger('PB',phonebook.Phones.Column[i].Caption,phonebook.Phones.Column[i].Width);
    //-*- 
    cfgini.WriteBool('Notes','WordWrap',PhoneBook.CheckBox1.Checked);
    cfgini.writeinteger('Notes','LW',PhoneBook.List.Width);
    cfgini.writeinteger('Notes','CP1L',PhoneBook.toolbar1.Left);
    cfgini.writeinteger('Notes','CP1T',PhoneBook.toolbar1.top);
    cfgini.writeBool('Notes','ConfirmDnD',PhoneBook.checkbox8.checked);
    //--    ----------------
    for i:=0 to PhoneBook.list.items.Count-1 do begin
      if PhoneBook.list.items.item[i].imageindex<>2 then
         cfgini.writebool('Expanded',PhoneBook.list.items.item[i].Text,PhoneBook.list.items.item[i].expanded);
      if PhoneBook.list.items.item[i].Selected then
         cfgini.writeString('Expanded','SelectedItem',PhoneBook.list.items.item[i].text);
    end;
  except
    writeLog(log,'LoadCfgError','CFG.pas->LoadCFG');
  end;
end;

end.
